# Класс lmbArrayHelper. Хелпер по работе с массивами
lmbArrayHelper используется для выполнения различных операций с массивами. Полностью статический класс, то есть содержит только статические методы.

##### Метод: **arrayMerge**($a1, $a2, [$a3, $a4, $aN…])
Назначение: Объединяет два и больше массивов в один. Поведение немного отличается от стандартной array_merge_recursive(), например, тем что если во втором массиве есть такое же поле, как и в первом, и это поле не является массив, второе значение полностью затрет первое.

##### Метод: **map**($map_array, $src_array, &$dest_array)
Назначение: Находит пересечение между массивами. Поведение немного отличается от стандартной array_intersect()

##### Метод: **explode**($pairs_delim, $values_delim, $string)
Назначение: Производить разбиение строки вида param1=value1;param2=value2 на наборы параметров. $pairs_delim — разделитель между парами ключ-значение, $values_delim — разделитель между ключем и значением.

Пример:

    $string = 'man:bob,dog:willy';
    $res = lmbArrayHelper :: explode(',', ':', $string);

##### Метод: **getColumnValues**($column_name, $array)
Назначение: Возвращает значения определенного поля массива

##### Метод: **getMaxColumnValue**($column_name, $array, &$index)
Назначение: Возвращает максимальное значение определенного поля массива. $index содержит номер позиции (вернее, позицию элемента массива) этого максимального значения в массиве

##### Метод: **getMinColumnValue**($column_name, $array, &$index)
Назначение: Возвращает минимальное значение определенного поля массива. $index содержит номер позиции (вернее, позицию элемента массива) этого минимального значения в массиве

##### Метод: **toFlatArray**($array, &$result, $prefix='')
Назначение: Возвращает содержимое массива в виде строки

Пример:

    lmbArrayHelper :: toFlatArray(array(1, 'apple' => 2, 'basket' => array('chips' => 3, 'nachoes' => 4)), $result)
    вернет array(1, 'apple' ⇒ 2, 'basket[chips]' ⇒ 3, 'basket[nachoes]' ⇒ 4)

##### Метод: **sortArray**($array, $sort_params, $preserve_keys = true)
Назначение: Позволяет сортировать массив сразу по нескольким колонкам. Правила сортировки передаются в параметр $sort_params, например $sort_params = array('field1' ⇒ 'DESC', 'field2' ⇒ 'ASC')

см. также тесты limb/core/tests/cases/lmbArrayHelperTest.class.php
