# Пакет IMAGEKIT
Пакет IMAGEKIT предоставляет средства, абстрагирующие работу с графической библиотекой.

В данный момент поддерживаются библиотеки GD и [ImageMagick](http://www.imagemagick.org/script/index.php).

## Пример работы

    lmb_require('limb/imagekit/src/lmbImageKit.class.php');
    //инициализируем библиотеку ImageMagick
    lmbImageKit::create('im')
      //загружаем файл с исходным изображением
      ->load('/www/images/input.jpg', 'jpeg')
        //изменяем размер изображения
        ->resize(array('width' => 100, 'height' => 100))
          //поворачиваем  изображение на угол, с указанием цвета фона
          ->rotate(array('angle' => 45, 'bgcolor' => 'FF0000'))
            //накладываем на изображение водяной знак
            ->waterMark(array('x' => 50, 'y' => 50, 'opacity' => 0, 'water_mark' => '/www/images/water_mark.gif'))
      //сохраняем модифицированное изображение
      ->save(dirname(__FILE__).'/images/output.jpg');

## Существующие фильтры (модификаторы)
Название | Назначение | Параметры
---------|------------|----------
crop | Обрезает изображение в указанный размер | **width** — ширина результата; **height** — высота результата; **x** — смещение точки отсчета по горизонтали; **y** — смещение точки отсчета по вертикали
resize | Изменяет размер изображения | **width** — ширина результата; **height** — высота результата; **preserve_aspect_ratio** — сохранять ли соотношение сторон
rotate | Поворачивает изображение на определенный угол | **angle** — угол поворота; **bgcolor** — цвет заднего фона
waterMark | Накладывает «водяной знак» на изображение | **water_mark** — файл с водяным знаком; **x** — смещение знака по горизонтали; **y** — смещение знака по вертикали; **opacity** — прозрачность знака; **xcenter** — считать ли горизонтальное смещение знака относительно его центра (по умолчанию от левого края); **ycenter** — считать ли вертикальное смещение знака относительно его центра (по умолчанию от верхнего края)

## Архитектура пакета

![Alt-Архитектура пакета](http://wiki.limb-project.com/2011.1/lib/exe/fetch.php?cache=&media=limb3:ru:packages:imagekit:arch.png)
