# Тег {{list:fill}}
## Описание
Выводит кусок кода определенное (вычисляемое) количество в случае, если количество элементов в списке некратно числу, указанному при помощи атрибута **upto**. Используется для генерации валидной верстки при выводе данных в несколько колонок или при использовании нестандартных разделителей.

см. также раздел [Вывод списков](../../list_tags.md)

## Синтаксис

    {{list:fill [upto='number'] [items_left="var_name"]}}
    ..some content
    {{/list:fill}}

## Область применения
Внутри тега [{{list}}](./list_tag.md).

## Атрибуты
* **upto (опционально)** — позволяет задать число, на кратность которому будет проверяться число элементов в списке. По-умолчанию равен 1.
* **items_left** — название переменной, которая получит в качестве значения недостающее число элементов для достижения кратности.

## Содержимое
Любое.

## Пример использования

    <h1>Valid layout with multi column output</h1>
    {{list using='$#modules'}}
      <table border='1'>
        <tr>
        {{list:item}}
          <td>{$item.name}</td>
          {{list:glue step='4'}}</tr><tr>{{/list:glue}}
        {{/list:item}}
        {{list:fill upto='4' items_left='$count'}}
          {{repeat count="{$count}"}}<td>&nbsp;</td>{{/repeat}}
        {{/list:fill}}
        </tr>
      </table>
    {{/list}}
